#include "powersaved.h"
#include "powerlib.h"
#include "cpufreq.h"
#include "powerlib.h"
#include "powersave_dbus.h"

#include <iostream>
#include <string>

using namespace std;

// constructor
clientConnection::clientConnection() {
}

//destructor
clientConnection::~clientConnection() {
	clients.clear();
}

bool clientConnection::addClient( const char* name, int capabilities ) {
	cNode client;

	/* unique name of the client */
	strcpy( client.name, (char*)name );
	client.name[DBUS_NAME_MAX-1] = '\0';

	client.capabilities = capabilities;

	// add the client to the list
	clients.push_back(client);

	return true;
}


bool clientConnection::checkClientRemoval( const char* name ) {
	for ( list<cNode>::iterator i = clients.begin();
	      i != clients.end(); ++i ) {

		if ( !strcmp( i->name, name ) ) {
			clients.erase( i );
			pDebug( DBG_INFO, "Removed client %s", name );
			return true;
		}
	}

	return false;
}

bool clientConnection::checkClientCapabilities( int capability ) {
	for ( list<cNode>::iterator i = clients.begin();
	      i != clients.end(); ++i ) {

		if ( i->capabilities & capability ) {
			return true;
		}
	}

	return false;
}

int clientConnection::count() {
	//return how much clients are connected
	return clients.size();
}
