_This readme is to help to get some powersave features running correctly on
Pentium 4 processors_


First: Pentium 4 CPUS are not designed for great energy saving issues. On
current processors (as far as I know) there is only throttling available to
decrease CPU performance and to save energy/heat production which is much less
efficient than SpeedStep technologie provided on modern Pentium M processors.

Note that there are also "Mobile Intel(R) Pentium(R) 4 - M CPU" (look in
/proc/cpuinfo) which are different and which do support speedstepping.

1) Be sure the processor module is loaded.

2) Check for C-states
Some machines might support additional C-(sleeping)states.
Do: cat /proc/acpi/processor/*/power
Are C2 or higher states supported? Fine you don't have to do anything, if your
processor is idle, the kernel will take care that those states are activated
-> just be sure the powersaved is running which loads the processor module at
boot time.

3) Throttling

For Pentium 4 processors there are 2 interfaces supported by kernel:
p4-clockmod module which exports the same files to /sys as cpufreq modules.
and the "normal", acpi interface.

Therefore you have two possibilities (none is set by default) to lower the
energy output of your CPU:

Do: cat /proc/acpi/processor/*/throttling
If you get not supported goto 2)

1) Use the PROCESSOR_DYNAMIC_LOW event (triggered when your CPU stays longer
   than 10 seconds below a specific CPU usage value (both are configurable)).

   Simply add throttle to the EVENT_PROCESSOR_IDLE event in
   /etc/sysconfig/powersave/events and dethrottle to
   EVENT_PROCESSOR_BUSY (see README.events for more details)

   In case the dynamic low event is triggerd, your machine will be slowed down
   to the limit you set in your current scheme file (when on AC power
   scheme_performance by default). Also set the variable
   ALLOW_THROTTLING there.

2) First check support by doing: modprobe p4-clockmod
   and: ls /sys/devices/system/cpu/cpufreq/ (must contain files).
   
   Set CPUFREQD_MODULE="p4-clockmod" in
   /etc/sysconfig/powersave/cpufreq and be sure you do not use the keyword
   "throttle" in the events config file (other interface -> double throttling
   can cause big trouble/slowdown)

   Now throttling is used as it would be Frequncy scaling.
   However you may experience your machine to be slower (specially when
   switching between windows very fast).
   Have a look into /etc/sysconfig/powersave/cpufreq config file and the
   README.cpufreq file to adjust the config values for better
   performance/powersavings.


