#include "string.h"
#include "config.h"

#include "powerlib.h"

#define SLEEP_PROC_FILE "/proc/acpi/sleep"


int64_t getSupportedSleepStates(void){

	char line[MAX_LINE_SIZE + 1];
	int test;
	FILE *fp;
	int ret = 0;
	test = checkACPI();
	if (test == ACPI){
		if ((fp = fopen(SLEEP_PROC_FILE, "r")) == NULL){
			pDebug(DBG_WARN, "Could not open %s file to evaluate supported sleeping states",
			       SLEEP_PROC_FILE);
			ret = 0;
		}
		else{
			if (fgets(line, MAX_LINE_SIZE, fp) == NULL){
				ret = 0;
			}
			else{
				if (strstr(line, "S1") != NULL)
					ret |= ACPI_S1;
				if (strstr(line, "S2") != NULL)
					ret |= ACPI_S2;
				if (strstr(line, "S3") != NULL)
					ret |= ACPI_S3;
				if (strstr(line, "S3_bios") != NULL)
					ret |= ACPI_S3_BIOS;
				if (strstr(line, "S4") != NULL)
					ret |= ACPI_S4;
				if (strstr(line, "S4_bios") != NULL)
					ret |= ACPI_S4_BIOS;
			}
			fclose(fp);
		}
	}
	else if (test == APM)
		/* do not evaluate APM any further for now */
		/* ToDO: are really both supported? */
		return APM_STANDBY + APM_SUSPEND;
	else{
		ret = 0;
	}
	return ret;
}
